(function () {
    /* ---------------------Single commands--------------------- */

    /* Create a directory */
    p7.commands.createDirectory = (name, filesystem) => p7.send.singleCommand(flashCommandSubtype.createDirectory, 0, 0, [name, '', '', '', filesystem, '']);

    /* Delete a directory */
    p7.commands.deleteDirectory = (name, filesystem) => p7.send.singleCommand(flashCommandSubtype.deleteDirectory, 0, 0, [name, '', '', '', filesystem, '']);

    /* Rename a directory */
    p7.commands.renameDirectory = (oldName, newName, filesystem) => p7.send.singleCommand(flashCommandSubtype.renameDirectory, 0, 0, [oldName, newName, '', '', filesystem, '']);

    /* Change working directory */
    p7.commands.changeDirectory = (name, filesystem) => p7.send.singleCommand(flashCommandSubtype.changeDirectory, 0, 0, [name, '', '', '', filesystem, '']);

    /* Delete a file */
    p7.commands.deleteFile = (directory, name, filesystem) => p7.send.singleCommand(flashCommandSubtype.deleteFile, 0, 0, [directory, name, '', '', filesystem, '']);

    /* Rename a file */
    p7.commands.renameFile = (directory, oldName, newName, filesystem) => p7.send.singleCommand(flashCommandSubtype.renameFile, 0, 0, [directory, oldName, newName, '', filesystem, '']);

    /* Copy a file */
    p7.commands.copyFile = (oldDirectory, oldName, newDirectory, newName, filesystem) => p7.send.singleCommand(flashCommandSubtype.copyFile, 0, 0, [oldDirectory, oldName, newDirectory, newName, filesystem, '']);

    /* Reset flash? */
    p7.commands.resetFlash = (filesystem) => p7.send.singleCommand(flashCommandSubtype.resetFlash, 0, 0, ['', '', '', '', filesystem, '']);

    /* Optimize filesystem */
    p7.commands.optimizeFilesystem = (filesystem) => p7.send.singleCommand(flashCommandSubtype.optimizeFileSystem, 0, 0, ['', '', '', '', filesystem, '']);

    /* ---------------------Single command requests--------------------- */

    /* Get free space */
    p7.commands.getCapacity = (filesystem) =>
        p7.send.singleCommandRoleswap(flashCommandSubtype.capacityTransmitRequest, 0, 0, ['', '', '', '', filesystem, ''],
            () => p7.decode.commandPacketFileSize()
        ).then((filteredData) => filteredData[0])
        .catch((err) => {
            err.message = "Couldn't get the size of the free space: " + err.message;
            throw err;
        });

    /* List files */
    p7.commands.list = (filesystem) =>
        p7.send.singleCommandRoleswap(flashCommandSubtype.fileInfoTransferAllRequest, 0, 0, ['', '', '', '', filesystem, ''], 
        () => ({
            size:          p7.decode.commandPacketFileSize(),
            DirectoryName: p7.decode.commandPacketDataField(1),
            name:          p7.decode.commandPacketDataField(2)
        })).catch((err) => {
            err.message = "Couldn't list files: " + err.message;
            throw err;
        });

}) ();
